您的位置:首页 > 其它

LeetCode oj 338. Counting Bits(DP)

2016-09-26 22:21 351 查看
338. Counting Bits QuestionEditorial Solution My Submissions

Total Accepted: 46702

Total Submissions: 79672

Difficulty: Medium

Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1's in their binary representation and return them as an array.

Example:

For num = 5 you should return [0,1,1,2,1,2].

Follow up:

It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?

Space complexity should be O(n).

Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.

输入一个数Num,问从0到Num每个数的二进制表示有多少个1。

第一次做LeetCode上的题,以为这上面的题都是暴力。。。看来想错了= =+,不过也是一道水DP,题目里说有O(n*m)的解法和O(n)的解法,前者很容易想,暴力求1的个数就可以,还可以预处理一下。O(n)的话就是DP了,状态转移方程很好想,dp[i] = dp[i>>1] + i%2;(默默吐槽一句用java写算法果然难受 = =+)

public class Problem338 {
public static int[] countBits(int num) {
int count [] = new int[num+1];
for(int i=0;i<=num;i++){
count[i] = count[i>>1] + i % 2;
}
return count;
}
public static void main(String [] args){
int re [] = countBits(8);
for(int i : re){
System.out.println(i);
}
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  338. Counting Bits